//****************************************************
//bnl|[gNXwb_i Win32 System Servicesj
//      comport.h       Ver 1.11        2003,05,21
//****************************************************
#ifndef _ComCtrl_H_
#define _ComCtrl_H_

#include <windows.h>
#include <string.h>		// str...
#include <Dialogs.hpp>		// ShowMessage

//-----------------------------------------------------
//e`
//-----------------------------------------------------

#define RX_EMPTY  -1

//----------------------------------------------------
//NX`
//----------------------------------------------------
class CommCtrl
{
public:
	__fastcall CommCtrl(void);
	          ~CommCtrl() { sio_close(); }

	bool  __fastcall IsValidComName(const char *ComName);
	bool  __fastcall ClearCommErrors(void);
	bool  __fastcall sio_open(void);
	void  __fastcall sio_close(void);
	int   __fastcall sio_putch(int c);
	int   __fastcall sio_puts(const char *str);
	int   __fastcall sio_printf(const char *f, void *_ap);
	int   __fastcall sio_in(void);
	DWORD __fastcall sio_read(char *dst, DWORD no);
	DWORD __fastcall sio_write(const char *str, DWORD no);
	bool  __fastcall sio_set_rts(int sw);
	bool  __fastcall sio_set_dtr(int sw);
	bool  __fastcall sio_rx_clr(void);
	DWORD __fastcall sio_get_stat(void);
	DWORD __fastcall sio_get_upc(void);		// 1̎(us)

// ȉ̐ݒ胁\bh sio_open() ŔfB
	bool  __fastcall SetComName       (const char *ComName  = "COM1"    );
	bool  __fastcall SetComBaudRate   (DWORD       BaudRate =  19200    );
	bool  __fastcall SetComBaudRateStr(const char *BaudRate = "19200"   );
	bool  __fastcall SetComByteSize   (BYTE        ByteSize =  8        );
	bool  __fastcall SetComByteSizeStr(const char *ByteSize = "8"       );
	bool  __fastcall SetComParity     (BYTE        Parity   = NOPARITY  );
	bool  __fastcall SetComParityStr  (const char *Parity   = "NONE"    );
	bool  __fastcall SetComStopBits   (BYTE        StopBits = ONESTOPBIT);
	bool  __fastcall SetComStopBitsStr(const char *StopBits = "1"       );
	bool  __fastcall SetComTxXflow    (bool        FlowSw   = false     );
	bool  __fastcall SetComRxXflow    (bool        FlowSw   = false     );
	bool  __fastcall SetComXonChar    (char        XonChar  = 0x11      );
	bool  __fastcall SetComXoffChar   (char        XonChar  = 0x13      );

private:
	char         P_ComName[21];
	DWORD        P_BaudRate;
	BYTE         P_ByteSize;
	BYTE         P_Parity;
	BYTE         P_StopBits;
	BOOL         P_XflowTx;
	BOOL         P_XflowRx;
	char         P_XonChar;
	char         P_XoffChar;

	COMMTIMEOUTS timeouts;

	DCB          Dcb;
	HANDLE       ComHandle;
	BOOL         Success;
};

#endif
