/*************************************************
ob-IVpRg[
        sosc.c          Ver 0.24        2004,09,16
gZ 2002,03t^bc̃R}hC
RpCi\H8Tool\DEVELOP\VER2.0\j gp

AE-3664FP gpLiteŒǉi67sڂ̒`ŐUւj
*************************************************/

/*-------------------------------------------------
CN[hEt@C
-------------------------------------------------*/
#if 0
@lTXEIWiwb_ 3664s.h or 3694s.h 
@ȉ̕ύXB
@ErbgtB[h`ŃtB[h󔒂̉ӏ
@@KȖOǉiVer 2.0 RpCŃG[ɂȂ邽߁jB
#endif

#if 0					/* gZ3694p */
  #define  CPUCLK       20000000	/* 20[MHz] */
  #define  BAUD_SP      BPS57600	/* 57600[bps] */
  #include "3694x.h"
#else					/* AE-3664FP p */
  #define  CPUCLK       16000000	/* 16[MHz] */
  #define  BAUD_SP      BPS38400	/* BPS38400[bps], BPS57600[bps] */
  #include "3664x.h"
#endif


#include <no_float.h>
#include <stdio.h>		/* NULL */

#include <machine.h>		/* set_imask_ccr() */

/*-------------------------------------------------
vg^Cv
-------------------------------------------------*/
void main(void);

#pragma noregsave INIT
void INIT(void);

#pragma interrupt(intr_tmv)
void intr_tmv(void);

/*-------------------------------------------------
e`
-------------------------------------------------*/
typedef	unsigned char	byte;
typedef	unsigned short	word;
typedef	unsigned long	dword;

#define OFF 0
#define ON  1

#define BUF_SIZE     250
#define AUTO_STT_CNT 150	/* AUTO Trig Jnʒu = 150 / 250 */

enum { TRG_AUTO, TRG_NORMAL, TRG_SINGLE };

/*-------------------------------------------------
AZup`
-------------------------------------------------*/
#pragma asm

NON_LITE	.ASSIGNA 0	; Liteł̂Ƃ 0, ŴƂ 1

TCSRV	        .equ	H'FFA1	; CPU Port Address
CMFA	        .equ	6	; CPU Port Address
ADDRA	        .equ	H'FFB0	; CPU Port Address
ADDRB	        .equ	H'FFB2	; CPU Port Address

BUF_SIZE        .equ	250
TRG_HYS         .equ	8
AUTO_STT_CNT    .equ	150	; AUTO Trig Jnʒu = 150 / 250

#pragma endasm

/*-------------------------------------------------
O[oϐ
-------------------------------------------------*/
/*
  Trig_inf
    b7:0 = CH1-Trig, 1 = CH2-Trig
    b6:0 = edge  , 1 = edge  
    b5:0 = NormTrig, 1 = AutoTrig
*/
byte Trig_inf       = 0x00;
byte Trig_mode      = 0x00;
byte SingleTrigFlag = OFF;
word Trig_level     = 0x100;

int  CHA_buf[BUF_SIZE + 1], CHB_buf[BUF_SIZE + 1];
int  Time_mul = 1;
int  Time_cnt = 1;
int  CHA_ofs  =   0, CHB_ofs  =   0;	/* -100 ` +100 */
int  CHA_gain = 100, CHB_gain = 100;	/* 100i~1.00j` 250i~2.50j */
int  Auto_cnt;
volatile int  Putptr = 0;
volatile byte Sttflg = OFF, Trgseq = 0;
volatile word CT_com;

/*-------------------------------------------------
xN^e[u
-------------------------------------------------*/
#pragma section vect1
const void (*const vec_table[])(void) = {
	INIT,				/*  0 0000 Reset          */
	NULL,				/*  1 0002 ї\       */
	NULL,				/*  2 0004 ї\       */
	NULL,				/*  3 0006 ї\       */
	NULL,				/*  4 0008 ї\       */
	NULL,				/*  5 000a ї\       */
	NULL,				/*  6 000c ї\       */
	NULL,				/*  7 000e NMI            */
	NULL,				/*  8 0010 TRAP#0     */
	NULL,				/*  9 0012 TRAP#1     */
	NULL,				/* 10 0014 TRAP#2     */
	NULL,				/* 11 0016 TRAP#3     */
	NULL,				/* 12 0018 ڽڰ     */
	NULL,				/* 13 001a SLEEP ڑJ */
	NULL,				/* 14 001c IRQ0           */
	NULL,				/* 15 001e IRQ1           */
	NULL,				/* 16 0020 IRQ2           */
	NULL,				/* 17 0022 IRQ3           */
	NULL,				/* 18 0024 WKP            */
	NULL,          			/* 19 0026 A           */
	NULL,				/* 20 0028 ї\       */
	NULL,    			/* 21 002a W           */
	intr_tmv,			/* 22 002c V           */
	NULL,                   	/* 23 002e SCI3           */
	NULL,				/* 24 0030 IIC            */
	NULL				/* 25 0032 A/D ϊI   */
};
#pragma section

/*-------------------------------------------------
CĂяoȌ
-------------------------------------------------*/

void INIT(void)
#pragma asm
	mov.w	#H'FF7E, R7
#pragma endasm
{
	set_imask_ccr(1);
	_INITSCT();		/* ZNV̏ */
	main();
}






/*-------------------------------------------------
t (a * b) / ciCC֐FړWJj
(16bit * 16bit = 32bit) / 16bit = 16bit
-------------------------------------------------*/
#pragma inline_asm(mul_div_s)
static short mul_div_s(short a, short b, short c)
{
	mulxs.w	e0, er0
	divxs.w	r1, er0
}

/*-------------------------------------------------
[v񐔂̃EFCgiCC֐FړWJj
-------------------------------------------------*/
#pragma inline_asm(wait)
static void wait(word no)
{
?1:	dec.w   #1, r0  ; 2
	bne     ?1:8    ; 4
}

#define us_no(us)    (((double)us * CPUCLK) / (6e6))
#define wait_us(us)  wait(us_no(us))







/**************************************************
W[
**************************************************/

/*=================================================
|[g̏
=================================================*/
void port_init(void)
{
	IO.PMR1.BYTE   = 0x0e;	/* P22:txd, P10,P14`P17:port */
	IO.PDR1.BYTE   = 0x00;	/* P10 all 0                  */
	IO.PCR1        = 0xff;	/* P10`P17:out               */
	IO.PUCR1.BYTE  = 0x00;	/* P10`P17:pull-up       */

	IO.PCR2        = 0x05;	/* P20:out, P21:rxd, P22:txd  */

	IO.PMR5.BYTE   = 0x00;	/* P50`P57:ėp I/O */
	IO.PCR5        = 0xff;	/* P50`P57:out */
	IO.PUCR5.BYTE  = 0x00;	/* P50`P57:pull-up  */ 

	IO.PDR7.BYTE   = 0x00;
	IO.PCR7        = 0x70;	/* P74`P76:out */

	IO.PDR8.BYTE   = 0x00;  /* P80 = all 0      */
	IO.PCR8        = 0xff;	/* P80`87: all out */
}












/**************************************************
A/D ֌W
**************************************************/

/*=================================================
A/D iXL[hj
=================================================*/
static void ad_init2(void)
{
	AD.ADCR .BYTE  = 0x00;	/* OgK */
	AD.ADCSR.BYTE  = 0x39;	/*  70state, AN0,1 ScanMode */
}











/**************************************************
SCI ֌W
**************************************************/
#define RX_EMPTY -1			/* sci_in() ̖M̋Al */

/*--------------- bits if[^rbgj -------*/
#define	BITS7   0x40
#define	BITS8   0x00

/*--------------- parityipeBj ------------*/
#define	NONE    0x00
#define	ODD     0x30		/*  */
#define	EVEN    0x20		/*  */

/*--------------- stop iXgbvrbgj -------*/
#define	STOP1   0x00
#define	STOP2   0x08

/*----------- int baud i{[[gj -----------*/

  #if   (CPUCLK == 16000000)
        #define BPS110    ((3 << 8) |  70)  /*  0.03% OK  */
        #define BPS150    ((2 << 8) | 207)  /*  0.16% OK  */
        #define BPS300    ((2 << 8) | 103)  /*  0.16% OK  */
        #define BPS600    ((1 << 8) | 207)  /*  0.16% OK  */
        #define BPS1200   ((1 << 8) | 103)  /*  0.16% OK  */
        #define BPS2400   ((0 << 8) | 207)  /*  0.16% OK  */
        #define BPS4800   ((0 << 8) | 103)  /*  0.16% OK  */
        #define BPS9600   ((0 << 8) |  51)  /*  0.16% OK  */
        #define BPS14400  ((0 << 8) |  34)  /* -0.79% OK  */
        #define BPS19200  ((0 << 8) |  25)  /*  0.16% OK  */
        #define BPS28800  ((0 << 8) |  16)  /*  2.12% OK  */
        #define BPS38400  ((0 << 8) |  12)  /*  0.16% OK  */
        #define BPS57600  ((0 << 8) |   8)  /* -3.55% NG? */
        #define BPS76800  ((0 << 8) |   6)  /* -6.99% NG  */
        #define BPS115200 ((0 << 8) |   3)  /*  8.51% NG  */

  #elif (CPUCLK == 20000000)
        #define BPS110    ((3 << 8) |  88)  /* -0.25% OK  */
        #define BPS150    ((3 << 8) |  64)  /*  0.16% OK  */
        #define BPS300    ((2 << 8) | 129)  /*  0.16% OK  */
        #define BPS600    ((2 << 8) |  64)  /*  0.16% OK  */
        #define BPS1200   ((1 << 8) | 129)  /*  0.16% OK  */
        #define BPS2400   ((1 << 8) |  64)  /*  0.16% OK  */
        #define BPS4800   ((0 << 8) | 129)  /*  0.16% OK  */
        #define BPS9600   ((0 << 8) |  64)  /*  0.16% OK  */
        #define BPS14400  ((0 << 8) |  42)  /*  0.94% OK  */
        #define BPS19200  ((0 << 8) |  32)  /* -1.36% OK  */
        #define BPS28800  ((0 << 8) |  21)  /* -1.36% OK  */
        #define BPS38400  ((0 << 8) |  15)  /*  1.73% OK  */
        #define BPS57600  ((0 << 8) |  10)  /* -1.36% OK  */
        #define BPS76800  ((0 << 8) |   7)  /*  1.73% OK  */
        #define BPS115200 ((0 << 8) |   4)  /*  8.51% NG  */
#endif

/*=================================================
SCI 
=================================================*/
static void sci_init(int baud, int bits, int parity, int stop)
{
	int smr_dat;

	smr_dat = bits | parity | stop | (baud >> 8);
	IO.PMR1.BIT.TXD = 1;		/* TXD [q */
	SCI3.SCR3.BYTE = 0x00;
	SCI3.SMR .BYTE = smr_dat;

	SCI3.BRR = baud;
	wait_us(104 + 10);		/* 1bit wait @ 9600[bps] */

	SCI3.SCR3.BYTE = 0x30;		/* TE, RE on */
}
/*=================================================
SCI 1 ́i|[Oj
@MĂ΁@Mf[^iint 0`255  jԂ
@M@@Ȃ΁@@@@@@iint RX_EMPTYjԂ
=================================================*/
static int sci_in(void)
{
	int data = RX_EMPTY;

	if (SCI3.SSR.BYTE & 0x38) {	/* OER, FER, PER   */
	    SCI3.SSR.BYTE &= ~0x78;	/* S װ ر & MNA */
	}
	if (SCI3.SSR.BIT.RDRF) {
/*	    SCI3.SSR.BIT.RDRF = 0; */	/* 36x4 ͕sv */
	    data = SCI3.RDR;
	}
	return data;
}
/*=================================================
SCI 1 M
=================================================*/
static int sci_putch(int c)
{
	while (SCI3.SSR.BIT.TDRE == 0);
	SCI3.TDR = c;
	return (unsigned char)c;
}















/*************************************************
^C}u֌W
*************************************************/

/*================================================
^C}uC^[oݗpƂĎgpꍇB
ERyA}b``gp
@Fno: /4 ̐i250[ns]@16[MHz], 200[nS]@20[MHz]j
l@FE݃xN^ 22 ݒ肷邱ƁB
@@@FEݏ֐擪ňȉs邱ƁB
@@@@@if (TV.TCSRV.BIT.CMFA) TV.TCSRV.BIT.CMFA = 0;
@@@@Eno <= 1fffH(8191)܂ŁB16[MHz] 2047[uS]
================================================*/
static void run_tmv_int(unsigned short no)
{
	unsigned char d = 2;

	while (no & 0xff00) { no >>= 1;  d++; }
	TV.TCORA = no;
	TV.TCRV1.BYTE = 0xe2 | (d & 0x01);
	TV.TCRV0.BYTE = 0x48 | ((d >> 1) & 0x03);
}
/*--------------------------------------------------
void run_tmv_int(unsigned short no)
 no l [us]wŋ߂}N֐
--------------------------------------------------*/
#define interval_us(us)  (unsigned short)(((double)us * CPUCLK) / 4e6 + 0.5)

















/**************************************************
20[uS] C^[oݏ
**************************************************/

/*+++++++++++++++++++++++++++++++++++++++++++++++++
TMV 荞ݏ֐
+++++++++++++++++++++++++++++++++++++++++++++++++*/
void intr_tmv(void)
{
/*      IO.PDR1.BIT.B7 = 1; */
#pragma asm
;	                                        ;15`27 ݉
	push.l	er0				;10 gpWX^̕ۑ
	push.l	er1				;10
	push.w	r2				; 6
	bclr	#CMFA, @TCSRV:8			; 8 TMV-CMFANA
;
	;-------- TvOԊǔvZ ---------
;
	mov.w	@_Time_cnt:16, r1		; 6 TIME-DIV 擾
	dec.w	#1, r1				; 2
	mov.w	r1, @_Time_cnt:16		; 6
	bne	qqq:16				; 4
	mov.w	@_Time_mul:16, r1		; 6
	mov.w	r1, @_Time_cnt:16		; 6

	;-------------- ADDT ̎擾 --------------
;
	mov.w	@ADDRA:16, e0			; 6 ADDTA  e0 
	mov.w	@ADDRB:16, e1			; 6 ADDTB  e1 Ɏ擾
;
 .AIF	\&NON_LITE EQ 1
	not.w	e0				; 2 ADDTA ɐ]
 .AENDI
	shlr.w	e0				; 2 b9-b0 т 10 bit ɂ 
	shlr.w	e0				; 2
	shlr.w	e0				; 2
	shlr.w	e0				; 2
	shlr.w	e0				; 2
	shlr.w	e0				; 2 e0 = ADDTA(10bit)
;
 .AIF	\&NON_LITE EQ 1
	not.w	e1				; 2 ADDTA ɐ]
 .AENDI
	shlr.w	e1				; 2 b9-b0 т 10 bit ɂ 
	shlr.w	e1				; 2
	shlr.w	e1				; 2
	shlr.w	e1				; 2
	shlr.w	e1				; 2
	shlr.w	e1				; 2 e1 = ADDTB(10bit)
;
	mov.w	@_Putptr:16, r2			; 6 i[ItZbg r2 Ɏ擾
	mov.b	@_Sttflg:16, r0l		; 6 JntOI ?
	bne	stt1:8				; 4 Ȃ玟
;
	mov.w	e0, @(_CHA_buf:16, er2)		; 6 i[̐擪 A/Dlۑ
	mov.w	e1, @(_CHB_buf:16, er2)		; 6 
	sub.b	r1l, r1l			;   gKV[PX
	mov.b	r1l, @_Trgseq:16		;   NA
	mov.w	#AUTO_STT_CNT, r1		;
	mov.w	r1, @_Auto_cnt:16
	bra	qqq:16				;   A
;
stt1:
	and.w	r2, r2				; 2 i[悪擪Ȃ
	beq	trg:8				; 4 gK҂
;
;-------------- f[^obt@Ɋi[ --------------
;
	mov.w	e0, @(_CHA_buf:16, er2)		; 6 i[ A/Dlۑ
	mov.w	e1, @(_CHB_buf:16, er2)		; 6 
;
	inc.w	#2, r2				; 2 i[i߂
	mov.w	r2 , @_Putptr:16		; 6
	cmp.w	#BUF_SIZE * 2, r2		; 4 ŏIȂ
	bcs	qqq:16				; 4
;
	sub.w	r2, r2				; 2 tO
	mov.b	r2l, @_Sttflg:16		; 6
	bra	qqq:16				; 4
;
;-------------------- gK --------------------
;
trg:
	mov.b	@_Trig_inf:16  , r2h		; 6 gKݒ
	mov.w	@_Trig_level:16, r1		; 6
;
	mov.w	e1, r0
	and.b	r2h, r2h			; 2 gKCHf[^ r0 
	bmi	trg0:8				; 4 gKCHU蕪
	mov.w	e0, r0
;
trg0:	shal.b	r2h				; 2 GbWU蕪
	bmi	trgn:8				;
;
	;----------- Positive Edge Trigger ----------
;
trgp:	mov.b	@_Trgseq:16, r2l		; 6 gKV[PX
	bne	trgp1:8				; 4
	add.w	#-TRG_HYS, r1			;
	cmp.w	r1, r0
	bcs	trg9:8
	bra	trga:8
trgp1:	cmp.w	r1, r0
	bcc	trgc:8
	bra	trga:8
;
	;----------- Negative Edge Trigger ----------
;
trgn:	mov.b	@_Trgseq:16, r2l		;
	bne	trgn1:8				;
	add.w	#TRG_HYS, r1			;
	cmp.w	r1, r0
	bcc	trg9:8
	bra	trga:8
trgn1:	cmp.w	r1, r0
	bcs	trgc:8
	bra	trga:8
;
;
	;---------------- AUTO Trig -----------------
;
trg9:	mov.b	#1, r1l				; 2 gKV[PXi߂
	mov	r1l, @_Trgseq:16		; 6
	mov.w	e0, @_CHA_buf:16		; 6
	mov.w	e1, @_CHB_buf:16		; 6
	bra	qqq:8
;
trga:	mov.w	e0, @_CHA_buf:16		; 6
	mov.w	e1, @_CHB_buf:16		; 6
	shal.b	r2h				; 2 Auto_Trig ?
	bpl	qqq:8				; 4
	mov.w	@_Auto_cnt:16, r1		; 6 Auto_Trig JnԌo ?
	bne	trga1:8
	xor.w	r2, r2
	bra	trgc1:8
;
trga1:	dec.w	#1, r1
	mov.w	r1, @_Auto_cnt:16		;
	bra	qqq:8
;
trgc:	mov.w	#2, r2				; 4 AUTO-Trig
	mov.w	e0, @(_CHA_buf:16, er2)		; 6
	mov.w	e1, @(_CHB_buf:16, er2)		; 6
;
trgc1:	inc.w	#2, r2				; 2 ߲i߂
	mov.w	r2, @_Putptr:16			; 6
;
qqq:
	;------------ ʐMՒfԔp ------------

	mov.w	@_CT_com, r0			; 6
	beq	qqq1:8				; 4
	dec.w	#1, r0				; 2
	mov.w	r0, @_CT_com			; 6
qqq1:
	pop.w	r2				; 6
	pop.l	er1				;10
	pop.l	er0				;10
	                                        ;10 RTE
#pragma endasm
/*      IO.PDR1.BIT.B7 = 0; */
}















/*-------------------------------------------------
Ԏ̔{߂
-------------------------------------------------*/
static int mk_time_mul(int i)
{
	int a = 1;

	switch (i & 0x0f) {
	    case  0:  a =      1;  break;   /* 500 uS */
	    case  1:  a =      2;  break;   /*   1 mS */
	    case  2:  a =      4;  break;   /*   2 mS */
	    case  3:  a =     10;  break;   /*   5 mS */
	    case  4:  a =     20;  break;   /*  10 mS */
	    case  5:  a =     40;  break;   /*  20 mS */
	    case  6:  a =    100;  break;   /*  50 mS */
	    case  7:  a =    200;  break;   /* 100 mS */
	    case  8:  a =    400;  break;   /* 200 mS */
	    case  9:  a =   1000;  break;   /* 500 mS */
	    case 10:  a =   2000;  break;   /*   1  S */
	    case 11:  a =   4000;  break;   /*   2  S */
	    case 12:  a =  10000;  break;   /*   5  S */
	    default:  a =      1;  break;
	}
	return  a;
}

/*-------------------------------------------------
SCI M
-------------------------------------------------*/
static void rx_job(void)
{
	static byte buf[20];
	static int n;
	int a;
	byte d;

	if ((a = sci_in()) == RX_EMPTY) return;
	if (a == 0xff) { n = 0;  buf[n++] = a; return; }
	if ((a == 0x00) && (n == 10)) {
	    IO.PDR5.BYTE = buf[1];
	    IO.PDR8.BYTE = buf[2] & 0x03;	/* AC Coupling SW */

	    Time_mul   = mk_time_mul(buf[3]);	/* Ԏ̔{ */

	    Trig_mode  = buf[4] & 0x07;		/* gK[h */

	    d = (buf[4] << 1) & 0xc0;		/* gK */
	    if (Trig_mode == TRG_AUTO) d |= 0x20;
	    Trig_inf   = d;
	    if (buf[4] & 0x08) SingleTrigFlag = ON;

	    Trig_level = 512 + (250 - ((int)buf[5] << 1));
	    CHA_ofs    = (int) buf[6] - 100;	/* 0`200 M -100`+100 */
	    CHB_ofs    = (int) buf[7] - 100;
	    CHA_gain   = (word)buf[8] + 100;	/* 0`150 M +100`+250 */
	    CHB_gain   = (word)buf[9] + 100;

	    CT_com = 50000;	/* ʐMՒfo = 20[uS]*50000 = 1[b] */

	    return;
	}
	if (n < sizeof(buf) ) buf[n++] = a;
}

/*=================================================
^[QbgEC֐
=================================================*/
static void target_main(void)
{
	word i;
	int d0, d1;

	while (1) {
	    rx_job();
	    if (CT_com == 0) continue;
	    if (Trig_mode == TRG_SINGLE) {
	        if (SingleTrigFlag == OFF) continue;
	        SingleTrigFlag = OFF;
	    }

	    Putptr = 0;  Trgseq = 0;  Auto_cnt = AUTO_STT_CNT;
	    Sttflg = ON;
	    sci_putch(0xff);  rx_job();  rx_job();
	    i = 0;
	    do {
	        rx_job();  rx_job();
	        if ((Putptr >> 1) > i) {
	            d0 = mul_div_s(CHA_buf[i] - 512, CHA_gain, 200) + 128 + CHA_ofs;
	            d1 = mul_div_s(CHB_buf[i] - 512, CHB_gain, 200) + 128 + CHB_ofs;
	            if (d0 <=   1) d0 = 1;
	            if (d0 >= 254) d0 = 254;
	            if (d1 <=   1) d1 = 1;
	            if (d1 >= 254) d1 = 254;
	            sci_putch(d0);  rx_job();  rx_job();
	            sci_putch(d1);  rx_job();  rx_job();
	            i++;
	        }
	    } while (i < BUF_SIZE);

	    sci_putch(0x00);  rx_job();  rx_job();

	    /*----- 1Ԉȏ̃Xy[X -----*/

	    for (i = 0; i < 200; i++) {
	        rx_job();
	        wait_us(5);
	    }
	}
}


/**************************************************
C
**************************************************/
void main(void)
{
	set_imask_ccr(1);		/* di(); */

	port_init();
	ad_init2();
	sci_init(BAUD_SP, BITS8, NONE, STOP1);
	run_tmv_int(interval_us(20));

	set_imask_ccr(0);		/* ei(); */
	target_main();
}
