//----------------------------------------------------------------------------
//Borland C++Builder
//Copyright (c) 1987, 1998 Borland International Inc. All Rights Reserved.
//----------------------------------------------------------------------------
//---------------------------------------------------------------------------
#ifndef canmainH
#define canmainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Chart.hpp>
#include <TeEngine.hpp>
#include <TeeProcs.hpp>

#include <time.h>	// time_t

#include <inifiles.hpp> // TIniFile
#include "comport.h"
#include <ComCtrls.hpp>
#include <Dialogs.hpp>



#define CRT_X_WIDTH  312
#define CRT_Y_MAX    125
#define CRT_Y_MIN   -125
#define CRT_Y_WIDTH  (CRT_Y_MAX - CRT_Y_MIN)

#define SMP_X_WIDTH  250
#define SMP_Y_MAX    125
#define SMP_Y_MIN   -125
#define SMP_Y_WIDTH  (SMP_Y_MAX - SMP_Y_MIN)



//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:    // IDE-managed Components 
    TTimer *Timer1;
    TPanel *PanelBezel;
    TImage *Image1;
    TGroupBox *GB_TRIG;
    TComboBox *CB_TRG_CH;
    TComboBox *CB_TRG_EG;
    TLabel *L_TRG_SRC;
    TLabel *L_TRG_SLOPE;
    TGroupBox *GB_CH1;
    TComboBox *CB_RNG1;
    TGroupBox *GB_CH2;
    TComboBox *CB_RNG2;
    TTrackBar *TB_OFS1;
    TTrackBar *TB_OFS2;
    TLabel *L_CH1_RANGE;
    TLabel *L_CH2_RANGE;
    TComboBox *CB_TRG_MD;
    TLabel *L_TRG_MODE;
    TTrackBar *TB_TRGL;
    TPanel *PanelCH1;
    TPanel *PanelCH2;
    TRadioButton *RB_TRGD;
    TCheckBox *CB_ACC1;
    TCheckBox *CB_ACC2;
    TButton *PB_Z2;
    TButton *PB_RES;
    TColorDialog *ColorDialog1;
    TPanel *Panel1;
    TPageControl *PageControl1;
    TTabSheet *TabSheet1;
    TStaticText *StaticText1;
    TComboBox *ComboBox1;
    TStaticText *StaticText2;
    TComboBox *CB_Br1;
    TTabSheet *TabSheet2;
    TButton *PB_COL_SCREEN;
    TButton *PB_COL_GRID;
    TPanel *Panel_CH1_PEN;
    TPanel *Panel_COL_GRID;
    TButton *PB_COL_CH1;
    TButton *PB_COL_CH2;
    TPanel *Panel_COL_BODY;
    TPanel *Panel_COL_SCREEN;
    TButton *PB_COL_DEF;
    TButton *PB_COL_VEZEL;
    TPanel *Panel_COL_BEZEL;
    TPanel *Panel_CH2_PEN;
    TButton *PB_COL_BODY;
    TStaticText *StaticText3;
    TButton *PB_Z1;
    TStaticText *StaticText4;
    TStaticText *StaticText5;
    TTrackBar *TB_GAIN1;
    TTrackBar *TB_GAIN2;
    TStaticText *StaticText6;
    TStaticText *StaticText7;
    TButton *PB_COL_KNOB;
    TPanel *Panel_COL_KNOB;
    TGroupBox *GB_HOR;
    TComboBox *CB_TMDIV;
    TGroupBox *GB_VMODE;
    TComboBox *CB_VMODE;
    TGroupBox *GB_MISC;
    TButton *PB_SETTING;
    TPanel *Panel2;
    TCheckBox *CB_HOLD;
    TPanel *Panel3;
    TCheckBox *CB_PILE;
    TLabel *L_TIME_DIV;
    TLabel *L_CH1X25;
    TLabel *L_CH2X25;
    TLabel *L_CH1X1;
    TLabel *L_CH2X1;
    TLabel *L_CH1P;
    TLabel *L_CH2P;
    TLabel *L_CH1N;
    TLabel *L_CH2N;
    TLabel *L_CH1Z;
    TLabel *L_CH2Z;
    TLabel *L_TRGP;
    TLabel *L_TRGZ;
    TLabel *L_TRGN;
    TCheckBox *CB_HX5;
    TTrackBar *TB_HX5;
    TPanel *Panel4;
    TCheckBox *CB_SNAP;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall ComboBox1Change(TObject *Sender);
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall FormPaint(TObject *Sender);

    void __fastcall CB_Br1Change(TObject *Sender);
    void __fastcall PB_Z1Click(TObject *Sender);
    void __fastcall PB_Z2Click(TObject *Sender);
    void __fastcall PB_RESClick(TObject *Sender);
    void __fastcall CB_TRG_MDChange(TObject *Sender);

    void __fastcall PB_SETTINGClick(TObject *Sender);

    void __fastcall PB_COL_CH1Click(TObject *Sender);
    void __fastcall PB_COL_CH2Click(TObject *Sender);
    void __fastcall PB_COL_BODYClick(TObject *Sender);
    void __fastcall PB_COL_KNOBClick(TObject *Sender);
    void __fastcall PB_COL_BEZELClick(TObject *Sender);
    void __fastcall PB_COL_SCREENClick(TObject *Sender);
    void __fastcall PB_COL_GRIDClick(TObject *Sender);
    void __fastcall PB_COL_DEFClick(TObject *Sender);

    
    void __fastcall TB_HX5Change(TObject *Sender);
    void __fastcall CB_HX5Click(TObject *Sender);
    void __fastcall CB_SNAPClick(TObject *Sender);

private:        // User declarations

    bool     CreateFlag;
    CommCtrl Ycom;                     // ʐM|[gNX

    AnsiString DefPath;                // OpenDailogpfBNg
    AnsiString IniPath;                // ".ini"t@C̊SpX

    int    CTcut, CT_tx, CT_td;

    int    CH1_buf[SMP_X_WIDTH + 1], CH1_putptr, CH1_ena;
    int    CH2_buf[SMP_X_WIDTH + 1], CH2_putptr, CH2_ena;
    bool   SingleTrigFlag;

    TColor Col_CH1Pen;
    TColor Col_CH2Pen;
    TColor Col_Body;
    TColor Col_Knob;
    TColor Col_Bezel;
    TColor Col_Screen;
    TColor Col_Grid;

    void __fastcall ReadIniFile(AnsiString path);
    void __fastcall WriteIniFile(AnsiString path, bool sw);

    void __fastcall SetComPortName(TComboBox *p);
    void __fastcall InitComPort(bool msgflag);

    void __fastcall unit_tx_job(void);
    void __fastcall unit_rx_job(void);
    void __fastcall unit_job(void);

    void __fastcall SetColor(void);

    int  __fastcall ScaleX(int a);
    int  __fastcall ScaleY(int a);
    void __fastcall PutData(int x, int d);
    void __fastcall InitScreen(TImage *p);
    void __fastcall DispData(TImage *p);
    void __fastcall ClrScreen(void);
    void __fastcall DspScreen(void);
    void __fastcall Snap(void);

//------------- bZ[Wnh -----------------
    void __fastcall FormExitSizeMove(TMessage &Message);

public:         // User declarations
    virtual __fastcall TForm1(TComponent* Owner);


BEGIN_MESSAGE_MAP

//--------------------------------------------------
// WM_EXITSIZEMOVEEChEbZ[WE
//--------------------------------------------------
    VCL_MESSAGE_HANDLER(WM_EXITSIZEMOVE, TMessage, FormExitSizeMove)

END_MESSAGE_MAP(TForm)

};
//---------------------------------------------------------------------------
extern TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
